<?php
/*
 */
/*
Plugin Name: Related Pages
Plugin URI: http:///
Description: With this plugin.
Author: Hispanic Market Advisor
Version: 1.0
Author URI: http://hispanicmarketadvisors.com/
*/

define( '__DIR_PLUGIN', plugin_dir_path( __FILE__ ) );
require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

if(!class_exists('WP_List_Table')){
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}

add_action("admin_menu","cc_opciones_de_admin_related_pages");
add_action("admin_init","cc_opciones_de_admin_init_related_pages");


if(!function_exists("cc_opciones_de_admin_related_pages"))
{
    function cc_opciones_de_admin_related_pages()
    {
        add_options_page("Related pages","Related pages","manage_options","Administrador-Related-Pages","cc_get_opciones_de_admin_related_pages");
    }
}

if(!function_exists("cc_opciones_de_admin_init_related_pages"))
{
    function cc_opciones_de_admin_init_related_pages()
    {
        register_setting("cc-group","cc_opciones_titulo");
        register_setting("cc-group","cc_opciones_description");
    }
}

if(!function_exists("saca_dominio_related"))
{
	function saca_dominio_related($url){
	    $protocolos = array('http://', 'https://', 'ftp://', 'www.');
	    $reemplazo_protocolo = array('[cambio_reemplazo_plugin1]','[cambio_reemplazo_plugin2]','[cambio_reemplazo_plugin3]','[cambio_reemplazo_plugin4]');
	    $url = explode('/', str_replace($protocolos, $reemplazo_protocolo, $url));
	    return str_replace($reemplazo_protocolo, $protocolos, $url[0]);
	}
}

if(!function_exists("cc_get_opciones_de_admin_related_pages"))
{
    function cc_get_opciones_de_admin_related_pages()
    {
    	if(isset($_GET['id'])){ 
    		global $wpdb;
    		$query = "SELECT * from ".$wpdb->prefix."related where post_ID=".$_GET['id'].";";
			$items = $wpdb->get_results($query, 'ARRAY_A');
			$tittle = "";
			$ID_related = 0;
			if($items){
				$tittle = $items[0]['tittle_list'];
				$ID_related = $items[0]['ID'];
			}

			$namelinks = $wpdb->get_results("SELECT * FROM $wpdb->postmeta where meta_key = 'custom_permalink' and post_id=".$_GET['id'].";", 'ARRAY_A');
			$namelinksvalor = $namelinks[0]['meta_value'];

			$query2 = "SELECT * FROM $wpdb->posts where ID=".$_GET['id'].";";
			$data = $wpdb->get_results($query2, 'ARRAY_A');
			$titulo = $data[0]["post_title"];
			$link = ($namelinks) ? saca_dominio_related($data[0]["guid"])."/".$namelinksvalor : saca_dominio_related($data[0]["guid"])."/".$data[0]["post_name"] ;
			
    		?>
    		<style type="text/css">
				#wpbody-content {
	    			padding-right: 25px;
	    			box-sizing: border-box;
	    		}
	    		#tittlerelated{
	    		    margin-top: 25px;
	    		}
	    		#postbox-container2{
	    			width: 100%;
	    		}
	    		h2.hndle{
	    			padding-left: 30px;
				    margin-top: 10px;
				    padding-bottom: 10px;
	    		}
	    		.input-new-related{
	    			width: 100%;
	    		}
	    		.postbox-container{
	    			width: 100%;
	    		}
	    		.continput{
	    			margin-top: 5px;
    				margin-bottom: 10px;
	    		}
	    		.related-part-1{
	    			display: inline-block;
	    			float: left;
	    			width: 40%;
	    		}
	    		.related-part-2{
					display: inline-block;
	    			float: left;
	    			width: 40%;
	    		}
	    		.related-part-3{
	    			display: inline-block;
	    			float: left;
	    			width: 20%;
	    		}
	    		.button{
	    			float: right;
				    width: 117px;
				    margin-top: 8px;
	    		}
	    		.related-post{
	    			overflow: hidden;
	    			cursor: move;
	    			padding: 10px;
				    background: #e5e5e5;
				    border-radius: 8px;
				    margin-bottom: 8px;
	    		}
	    		.inside{
	    			overflow: hidden;
	    		}
			</style>
			<h1 id="tittlerelated">Edit Related Posts <span style="font-size:13px;"><a target='_blank' href='<?= $link ?>'><?= $titulo ?></a></span></h1>
			<input id="idrelated" type="hidden" value="<?= $_GET['id'] ?>">
			<div id="postbox-container2" class="postbox-container">
				<div id="normal-sortables" class="meta-box-sortables ui-sortable">
					<div id="post-related-posts-box" class="postbox ">
						<button type="button" class="handlediv button-link" aria-expanded="true">
							<span class="toggle-indicator" aria-hidden="true"></span>
						</button>
						<h2 class="hndle ui-sortable-handle" style="margin-bottom:0px;"><span>Related posts</span></h2>

						<div class="inside">
							<p style="margin-top:0px;">Choose related posts. You can drag-and-drop them into the desired order:</p>
							<div id="related-posts" class="ui-sortable">

							</div>
							<div id="related-btn">
								
							</div>
						</div>
					</div>
				</div>
				<div id="advanced-sortables" class="meta-box-sortables ui-sortable"></div>
			</div>
			<div style="overflow: hidden;box-sizing: border-box;width: 527px;background: #fff;border-radius: 8px;padding: 10px 20px 20px 20px;">
				<h2>New related posts</h2>
				<div class="postbox-container">
					<div class="cont">
						<label>Links references: </label>
						<select id="select-references" class="form-input-tip" style="width: 240px;margin-left: 15px;">
							
						</select>
						<input name="save" id="btn-select-combo" type="button" class="button button-primary button-large" value="Select to edit">
					</div>
					<div class="cont">
						<div class="continput">
							<label>Name related post : </label>
							<input type="text" id="input-name-related" class="input-new-related form-input-tip">
						</div>
						<div class="continput">
							<label>Url : </label>
							<input type="text" id="input-url-related" class="input-new-related form-input-tip">
						</div>
						<div class="continput">
							<input name="save" id="btn-insertar" type="button" class="button button-primary button-large" value="Save">
						</div>
					</div>
				</div>
			</div>
			<div style="margin-top:30px;overflow: hidden;box-sizing: border-box;width: 46%;background: #fff;border-radius: 8px;padding: 10px 20px 20px 20px;">
				<h2>Tittle related posts</h2>
				<div class="postbox-container">
					<div class="cont">
						<div class="continput">
							<label>Title for the list of related posts : </label>
							<input type="text" value="<?= $tittle ?>" id="input-tittle" class="input-new-related form-input-tip">
						</div>
						<div class="continput">
							<input name="save" type="button" id="btn-tittle" class="button button-primary button-large" value="Save">
						</div>
					</div>
				</div>
			</div>
			<?php
			wp_enqueue_script ( 'my_ajax', plugin_dir_url( __FILE__ ) . '_inc/jquery.js','jquery','1.0.0' );
			wp_enqueue_script ( 'my_ajax2', plugin_dir_url( __FILE__ ) . '_inc/jquery-ui.js','jquery-ui','1.0.0' );
			wp_localize_script( 'my_ajax', 'MyAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
			?>
			<script type="text/javascript" src="<?php echo plugin_dir_url( __FILE__ ) . '_inc/jquery.js'; ?>"></script>
			<script type="text/javascript" src="<?php echo plugin_dir_url( __FILE__ ) . '_inc/jquery-ui.js'; ?>"></script>
			<script type="text/javascript">
				$(document).ready(function(){
					actualizar();
					$(".toggle-indicator").click(function(){
						$(".inside").toggle();
					});
					$("#btn-select-combo").click(function(){
						$("#input-name-related").val($('#select-references option:selected').text());
						$("#input-url-related").val($('#select-references option:selected').data("url"));
					});
					$("#btn-tittle").click(function(){
						$.post( MyAjax.ajaxurl, {id:$("#idrelated").val(),tittle:$("#input-tittle").val(),action:"insertar_tittle_related"}, function( data ) {
						   if(data.status){

						   }else{
						   		alert(data.msg);
						   }
						},'json');
					});
					$("#btn-insertar").click(function(){
						$.post( MyAjax.ajaxurl, {id:$("#idrelated").val(),name:$("#input-name-related").val(),url:$("#input-url-related").val(),action:"insertar_related"}, function( data ) {
						   if(data.status){
						   		actualizar();
						   		$("#input-name-related").val("");
						   		$("#input-url-related").val("");
						   }else{
						   		alert(data.msg);
						   }
						},'json');
					});
					
				});
				function eventos(){
					$(".edit-related").unbind("click");
					$(".delete-related").unbind("click");
					$("#btn-update-sort").unbind("click");
					$(".delete-related").click(function(e){
						e.preventDefault();
						var ids=$(this).data("id");
						$.post( MyAjax.ajaxurl, {id:$(this).data("id"),action:"delete_related"}, function( data ) {
						   if(data.status){
						   		actualizar();
						   }else{
						   		alert(data.msg);
						   }
						},'json');
					});
					$(".edit-related").click(function(e){
						e.preventDefault();
					});
					$("#btn-update-sort").click(function(){
						var orden = "";
						$('.related-post').each(function(key, element){
						  orden += $(element).data('id')+",";
						});
						orden = (orden=="")?"":orden.substring(0, orden.length-1);

						id = $("#idrelated").val();
						$.post( MyAjax.ajaxurl, {id:id,orden:orden,action:"update_sort_related"}, function( data ) {
							if (data.status) {
								actualizar();
							}else{
								alert(data.msg);
							}
						},'json');
					});
				}
				function actualizar(){
					id = $("#idrelated").val();
					$.post( MyAjax.ajaxurl, {id:id,action:"actualizar_related"}, function( data ) {
						$("#related-posts").html(data.html);
						$("#related-btn").html(data.btn);
						$("#select-references").html(data.combo);
						$( "#related-posts" ).sortable({
					      revert: true
					    });
						eventos();
					},'json');
				}
				
			</script>
    	<?php
    	}else{

	    	$listTable = new table_wordpress_related();
		    $listTable->prepare_items();
			?>
			<style type="text/css">
				#wpbody-content {
	    			padding-right: 25px;
	    			box-sizing: border-box;
	    		}
	    		#tittlerelated{
	    		    margin-top: 25px;
	    		}
	    		.type,.cant,#type,#cant,.column-type,.column-cant{
	    			text-align: center!important;
	    		}
			</style>
			<h1 id="tittlerelated">Related Pages</h1>
			<p>Description related pages.</p>
			<?php
				$listTable->display(); 
			?>
			<script type="text/javascript" src="<?php echo plugin_dir_url( __FILE__ ) . '_inc/jquery.js'; ?>"></script>
			<script type="text/javascript" src="<?php echo plugin_dir_url( __FILE__ ) . '_inc/jquery-ui.js'; ?>"></script>
	    	<?php
    	}
    }
}

if(!function_exists("create_table_related"))
{
	function create_table_related() {
	 
	  global $wpdb;
	  $nombreTabla2 = $wpdb->prefix . "related_detail";
	  $nombreTabla = $wpdb->prefix . "related";
	  
	  $created = dbDelta(  
	  	"CREATE TABLE $nombreTabla (
	      ID bigint(20) unsigned NOT NULL AUTO_INCREMENT,
	      post_ID int NOT NULL,
	      tittle_list text NOT NULL,
	      PRIMARY KEY (ID)
	    ) CHARACTER SET utf8 COLLATE utf8_general_ci;

	  	CREATE TABLE $nombreTabla2 (
	      ID_detail bigint(20) unsigned NOT NULL AUTO_INCREMENT,
	      ID_related bigint(20) not null,
	      sort int NOT NULL,
	      url text NOT NULL DEFAULT '',
	      name text NOT NULL,
	      PRIMARY KEY (ID_detail)
	    ) CHARACTER SET utf8 COLLATE utf8_general_ci;"
	  );
	} 
}




register_activation_hook( __FILE__, 'create_table_related' );
 


add_filter( 'the_content', 'related_post_add' );
if(!function_exists("related_post_add")){
	function related_post_add( $content) {

		global $wpdb;
		$nombreTabla = $wpdb->prefix . "related";
		$query = "SELECT rd.*,r.tittle_list from ".$wpdb->prefix."related as r inner join ".$wpdb->prefix."related_detail as rd on r.ID=rd.ID_related where r.post_ID=".get_the_ID()." order by sort asc;";
		$items = $wpdb->get_results($query, 'ARRAY_A');

		$html = "";
		if($items){
			$html .= '<h2 style="margin-bottom:8px;">'.$items[0]['tittle_list'].'</h2>';
			$html .= '<ul style="margin-bottom: 25px;">';
			foreach ($items as $key => $value) {
				$html.="<li><a target='_blank' href='".$value['url']."'>".$value['name']."</li>";
			}
			$html .= '</ul>';
		}
		

		return $html.$content;
	}
}

abstract class Simple_WP_Table_related extends WP_List_Table {
	
	private $per_page = 26;
	
	function __construct($options, $per_page = NULL) {
		global $status, $page;
		
		//Set parent defaults
		parent::__construct($options);
		
		if ($per_page) {
			$this->per_page = $per_page;
		}
	}

	function column_default($item, $column_name){
		return $item[$column_name];
	}
	
	function column_cb($item){
		return '';
	}

	function prepare_items() {
		global $wpdb;

		$namelinks = $wpdb->get_results("SELECT * FROM $wpdb->postmeta where meta_key = 'custom_permalink';", 'ARRAY_A');
		$todosLinksOriginales = Array();
		foreach ($namelinks as $key => $value) {
			$todosLinksOriginales[$value["post_id"]] = $value["meta_value"];
		}

		$query = "SELECT *,(SELECT count(*) from ".$wpdb->prefix."related as r inner join ".$wpdb->prefix."related_detail as rd on rd.ID_related=r.ID where r.post_ID=p.ID) as cant FROM $wpdb->posts as p where post_status='publish' and (post_type='page' OR post_type='post')";

		$total_items = $wpdb->query($query);
		$paged = !empty($_GET["paged"]) ? mysql_real_escape_string($_GET["paged"]) : '';
		if(empty($paged) || !is_numeric($paged) || $paged<=0 ){ $paged=1; }

		if(!empty($paged)){
			$this->per_page = (isset($_GET['paged'])) ? $_GET['paged'] : 1;
			$numero_por_pagina = (isset($_GET['per_page'])) ? $_GET['per_page'] : 20;
			$query.=' LIMIT '.($numero_por_pagina*($this->per_page-1)).','.$numero_por_pagina;
		}

		$columns = $this->get_columns();
		$hidden = array();
		$sortable = $this->get_sortable_columns();
		$this->_column_headers = array($columns, $hidden, $sortable);		   

		$this->process_bulk_action();
		
		$this->items = $wpdb->get_results($query, 'ARRAY_A');
		$array = array();

			foreach ($this->items as $key => $value) {
				$valorGuid = (isset($todosLinksOriginales[$value["ID"]])) ? saca_dominio_related($value["guid"])."/".$todosLinksOriginales[$value["ID"]] : saca_dominio_related($value["guid"])."/".$value["post_name"] ;
								
					array_push($array, array(
						"tittle" => $value["post_title"],
						"url" => "<a target='_blank' href='".$valorGuid."'>".$valorGuid."</a>",
						"type" => $value["post_type"],
						"cant" => $value["cant"],
						"cambiar" => "<a target='_blank' href='options-general.php?page=Administrador-Related-Pages&id=".$value["ID"]."' class='cambiar' style='cursor:pointer'>Edit</a>" ,
					));
			}


		// Register the pagination
		$current_page = $this->get_pagenum();
		$this->set_pagination_args( array(
			'total_items' => $total_items,
			'total_pages' => ceil($total_items/$numero_por_pagina),
			'per_page' => $numero_por_pagina,
		) );

		$this->items = $array;
	
	}
	
	function display() {
		?>
		<form method="get">
			<input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
			<?php parent::display(); ?>
		</form>
		<?php
	}
}

class table_wordpress_related extends Simple_WP_Table_related {
	
	function __construct() {
		parent::__construct(array(
			'singular'  => 'gallery',     //singular name of the listed records
			'plural'    => 'galleries',    //plural name of the listed records
			'ajax'      => false        //does this table support ajax?
		), 5);
	}

	/**
	 * Define the columns that are going to be used in the table
	 * @return array $columns, the array of columns to use with the table
	 */

	public $_actions = null;

	function get_columns() {
		return array(
				'tittle' => ('Tittle'),
				'url' => ('Url'),
				'type' => ('# Types of Content'),
				'cant' => ('Amount of post related'),
				'cambiar' => ('Action')
		);
	}

	/**
	 * Decide which columns to activate the sorting functionality on
	 * @return array $sortable, the array of columns that can be sorted by the user
	 */
	public function get_sortable_columns() {
		return array(
			'src' => array('src')
		);
	}


	protected function get_views() { 
	    $status_links = array(
	        "all"       => __("<a href='#'>All</a>",'my-plugin-slug'),
	        "published" => __("<a href='#'>Published</a>",'my-plugin-slug'),
	        "trashed"   => __("<a href='#'>Trashed</a>",'my-plugin-slug')
	    );
	    return $status_links;
	}
}



add_action( 'wp_ajax_insertar_tittle_related', 'insertar_tittle_related' );

if(!function_exists("insertar_tittle_related"))
{
	function insertar_tittle_related() {
		global $wpdb;
    	$id = $_POST['id'];
    	$tittle = $_POST['tittle'];
		$query = "SELECT * from ".$wpdb->prefix."related where post_ID=".$id.";";
		$total_items = $wpdb->query($query);
		$items = $wpdb->get_results($query, 'ARRAY_A');

		if($total_items==0){
			$insert = $wpdb->insert($wpdb->prefix . "related", array( 'post_ID' => $id , 'tittle_list' => $tittle));
			if(!$insert){
				echo json_encode(array("status"=>false,"msg"=>$wpdb->print_error()));
			}else{
				echo json_encode(array("status"=>true,"tittle"=>$tittle));
			}
		}else{
			$update = $wpdb->update($wpdb->prefix . "related", array( 'tittle_list' => $tittle ) , array( 'post_ID' => $id ));
			if(!$update){
				echo json_encode(array("status"=>false,"msg"=>$wpdb->print_error()));
			}else{
				echo json_encode(array("status"=>true,"tittle"=>$tittle));
			}
		}

		wp_die();
	}
}

add_action( 'wp_ajax_insertar_related', 'insertar_related' );

if(!function_exists("insertar_related"))
{
	function insertar_related() {
		global $wpdb;
    	$id = $_POST['id'];
    	$name = $_POST['name'];
    	$url = $_POST['url'];
		$query = "SELECT * from ".$wpdb->prefix."related where post_ID=".$id.";";
		$total_items = $wpdb->query($query);
		$items = $wpdb->get_results($query, 'ARRAY_A');

		if($total_items==0){
			$wpdb->insert($wpdb->prefix . "related", array( 'post_ID' => $id , 'tittle_list' => ''));
			$idrelated = $wpdb->insert_id;

			$insert = $wpdb->insert($wpdb->prefix . "related_detail", array( 'ID_related' => $idrelated , 'sort' => 1 , 'url' => $url , 'name' => $name));
			$id_detail = $wpdb->insert_id;
			if(!$insert){
				echo json_encode(array("status"=>false,"msg"=>$wpdb->print_error()));
			}else{
				echo json_encode(array("status"=>true,"html"=>$html));
			}

		}else{
			$idrelated = $items[0]['ID'];

			$query = "SELECT * from ".$wpdb->prefix."related_detail where ID_related=".$idrelated.";";
			$sort = $wpdb->query($query);

			$insert = $wpdb->insert($wpdb->prefix . "related_detail", array( 'ID_related' => $idrelated , 'sort' => $sort+1 , 'url' => $url , 'name' => $name));
			if(!$insert){
				echo json_encode(array("status"=>false,"msg"=>$wpdb->print_error()));
			}else{
				echo json_encode(array("status"=>true));
			}
		}

		wp_die();
	}
}


add_action( 'wp_ajax_delete_related', 'delete_related' );

if(!function_exists("delete_related"))
{
	function delete_related() {
		global $wpdb;
    	$id = $_POST['id'];
		
		$delete = $wpdb->delete($wpdb->prefix . "related_detail", array( 'ID_detail' => $id ));

		if(!$delete){
			echo json_encode(array("status"=>false,"msg"=>$wpdb->print_error()));
		}else{
			echo json_encode(array("status"=>true));
		}

		wp_die();
	}
}

add_action( 'wp_ajax_actualizar_related', 'actualizar_related' );

if(!function_exists("actualizar_related"))
{
	function actualizar_related() {
		global $wpdb;
    	$id = $_POST['id'];
		
		$query = "SELECT rd.* from ".$wpdb->prefix."related as r inner join ".$wpdb->prefix."related_detail as rd on r.ID=rd.ID_related where r.post_ID=".$id." order by sort asc;";
		$items = $wpdb->get_results($query, 'ARRAY_A');
		$html = "";
		$btn = "";
		$contar = 0;
		foreach ($items as $key => $value) { 
			$html .= '<div class="related-post ui-sortable-handle" data-id="'.$value['ID_detail'].'" id="related-post-'.$value['ID_detail'].'">';
			$html .= '<div class="related-part-1"><span class="related-post-title">'.$value['name'].'</span></div>';
			$html .= '<div class="related-part-2"><a target="_blank" style="float:left;" href="'.$value['url'].'">'.$value['url'].'</a></div>';
			$html .= '<div class="related-part-3"><a data-id="'.$value['ID_detail'].'" class="delete-related" style="cursor:pointer;">Delete</a></div>';
			$html .= '</div>';
			$contar = $contar + 1;
		}
		if ($contar>1) {
			$btn = '<input name="save" id="btn-update-sort" type="button" class="button button-primary button-large" value="Update sort">';
		}

		$namelinks = $wpdb->get_results("SELECT * FROM $wpdb->postmeta where meta_key = 'custom_permalink';", 'ARRAY_A');
		$todosLinksOriginales = Array();
		foreach ($namelinks as $key => $value) {
			$todosLinksOriginales[$value["post_id"]] = $value["meta_value"];
		}

		$query = "SELECT * FROM $wpdb->posts where ID=".$id.";";
		$items = $wpdb->get_results($query, 'ARRAY_A');
		$tittle = $items[0]["post_title"];
		$no_permitidas= array ("á","é","í","ó","ú","Á","É","Í","Ó","Ú","/","-","(",")");
		$permitidas= array ("a","e","i","o","u","A","E","I","O","U"," "," "," "," ");
		$tittle_new = strtolower(str_replace($no_permitidas,$permitidas,$tittle));
		$arraytittle = explode(" ",$tittle_new);
		$new_query="SELECT * FROM $wpdb->posts where ID!=".$id." and post_status='publish' and (post_type='page' OR post_type='post') ";
		$new_query2="";
		$aux=0;
		foreach ($arraytittle as $key) {
			if(strlen($key)>3){
				$new_query2.= "or post_title like '%".$key."%' ";
				$aux = $aux+1;
			}
		}
		if($aux != 0){
			$new_query2 = substr($new_query2, 2);
			$new_query.= "and (".$new_query2.")";
		}

		$combo = "";
		$it = $wpdb->get_results($new_query, 'ARRAY_A');
		foreach ($it as $key => $value) { 
			$valorGuid = (isset($todosLinksOriginales[$value["ID"]])) ? saca_dominio_related($value["guid"])."/".$todosLinksOriginales[$value["ID"]] : saca_dominio_related($value["guid"])."/".$value["post_name"] ;
			$combo .= '<option data-url="'.$valorGuid.'">'.$value['post_title'].'</option>';
		}


		echo json_encode(array("html"=>$html,"btn"=>$btn,"combo"=>$combo));

		wp_die();
	}
}

add_action( 'wp_ajax_update_sort_related', 'update_sort_related' );

if(!function_exists("update_sort_related"))
{
	function update_sort_related() {
		global $wpdb;
    	$id = $_POST['id'];
    	$orden = $_POST['orden'];
		$contar = 1;
		$arrayorden = explode(",",$orden);
		foreach ($arrayorden as $key) {
			$wpdb->update($wpdb->prefix."related_detail", array( 'sort' => $contar), array( 'ID_detail' => $key ));
			$contar = $contar +1;
		}

		echo json_encode(array("status"=>true));

		wp_die();
	}
}

